#include <vga.h>
#include <vgagl.h>
#include <stdlib.h>

typedef unsigned char byte;

#ifdef NOT_YET
//
// this code should be faster but is highly vgagl implementaion dependent
// and doesn't work for modes other then 8bpp ;(((( [there is some small
// bug somewhere around...]
//

inline void scale_line(register byte * dst, register byte * src,
		       int w_dst, int w_src, register int n)
{
	register int d = (w_src << 16) / w_dst;
	register int v = 0;

	switch (BYTESPERPIXEL) {
	case 1:
		while (n-- > 0) {
			*dst++ = src[v >> 16];
			v += d;
		}
		break;
	case 2:
		while (n-- > 0) {
			*((short *) dst)++ = ((short *) src)[v >> 16];
			v += d;
		} 
		break;
	case 3:
		while (n-- > 0) {
			register int k = v >> 16;
			register byte *p = src + k + k + k;
			*dst++ = *p++;
			*dst++ = *p++;
			*dst++ = *p;
		}
		break;
	case 4:
		while (n-- > 0) {
			*((int *) dst)++ = ((int *) src)[v >> 16];
			v += d;
		} 
		break;
	default:
		abort();
	}
}

void x_putboxscaled(int sx, int sy, int sw, int sh,	// on-screen pos/size
		    int bx, int by, int bw, int bh,	// on-bitmap pos/size
		    void *b)
{
	byte *p;
	int i;
	int dy, y;
	int ww, bbw, www;

	bbw = bw * BYTESPERPIXEL;

	dy = (bh << 16) / sh;

	if (sh +sy > HEIGHT)
		sh = HEIGHT - sy;
	if (sh <0)
		return;

	if (sw + sx > WIDTH)
		ww = WIDTH - sx;
	else
		ww = sw;
	y = by << 16;
	b = (byte *) b + bx * BYTESPERPIXEL;
	www = ww * BYTESPERPIXEL;
	
	if (MODETYPE == CONTEXT_LINEAR) {
		byte *vp = VBUF + sy * BYTEWIDTH + sx;

		for (i = 0; i < sh; i++) {
			p = (byte *) b + (y >> 16) * bbw;
			y += dy;
			scale_line(vp, p, sw, bw, ww);
			vp += BYTEWIDTH;
		}
	} else {
		int vp;
		int page;

		vp = sy * BYTEWIDTH + sx;
		page = vp >> 16;
		vp &= 0xffff;
		vga_setpage(page);

		for (i = 0; i < sh; i++) {
			p = (byte *) b + (y >> 16) * bbw;
			y += dy;
			
			if (vp >= 0x10000) {
				page++;
				vga_setpage(page);
				vp &= 0xffff;
			} else if (vp + www > 0x10000) {
				// page break within line 
				scale_line((byte *) (VBUF + vp), p, sw, bw,
					   (0x10000 - vp) / BYTESPERPIXEL);
				page++;
				vga_setpage(page);
				scale_line((byte *) VBUF,
					   p + ((0x10000 - vp) * bw / sw) * BYTESPERPIXEL,
					   sw, bw, ((vp + www) & 0xffff) / BYTESPERPIXEL);
				vp = (vp + BYTEWIDTH) & 0xffff;
				continue;
			}
			scale_line((byte *) (VBUF + vp), p, sw, bw, ww);
			vp += BYTEWIDTH;
		}
	}
}

#else /* NOT_YET */

void x_putboxscaled(int sx, int sy, int sw, int sh,	// on-screen pos/size
		    int bx, int by, int bw, int bh,	// on-bitmap pos/size
		    void *b)
{
	int dx, dy;
	int rx, ry; // real
	byte *tmp, *dst;
	int nn;
	
	if (!sw || !sh ||!bw || !bh)
		return;
		
	dx = (bw << 16) / sw;
	dy = (bh << 16) / sh;
	rx = WIDTH - sx; if (rx > sw) rx = sw;
	ry = HEIGHT - sy; if (ry > sh) ry = sh;
	
	tmp = malloc(rx * ry * BYTESPERPIXEL);
	bw *= BYTESPERPIXEL;
	by <<= 16;
	bx <<= 16;
	dst = tmp;
	nn = ry;
	
#define blah1 \
	while (nn-- > 0) { \
		byte *src = (byte *) b + (by >> 16) * bw; \
		int n = rx; \
		int x = bx; \
		\
		by += dy; \
		while (n-- > 0) {
#define blah2 	x += dx; } }

	switch (BYTESPERPIXEL) {
	case 1:
		blah1
		*dst++ = src[x >> 16];
		blah2
		break;
	case 2:
		blah1
		*((short*)dst)++ = ((short*)src)[x >> 16];
		blah2
		break;
	case 3:
		blah1
		// i belive this (x >> 16) will go to tmp reg ...
		byte *p = src + (x >> 16) + (x >> 16) + (x >> 16);
		*dst++ = *p++;
		*dst++ = *p++;
		*dst++ = *p++;
		blah2
		break;
	case 4:
		blah1
		// i think this 'll be optimised
		// m68k had a special mode for .l indexing
		// i'm not sure about ix86
		*((int*)dst)++ = ((int*)src)[x >> 16];
		blah2
		break;
	default:
		abort();
	}
#undef blah1
#undef blah2
	gl_putbox(sx, sy, rx, ry, tmp);
	free(tmp);
}

#endif /* NOT_YET */
